<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Create New Job From Template</title>
</head>

<body background="images/background.gif" bgcolor="#f0e68c" text="#000000" link="#008080" vlink="#800000" alink="#ff0000">

<table border="0" cellpadding="3" cellspacing="3" width="100%">
    <tr>
        <td valign="top" nowrap><h2>Create New Job<br>From Template</h2></td>
        <td align="right" valign="top">
			<a href="job_list.asp">Job List</a> | 
			<a href="logout.asp">Logout</a> 
		</td>
    </tr>
</table>

<hr>

<form action="create.asp?TYPE=template" method="post">
<table>
	<tr>
		<td align=left valign=top>Enter job name:<br>&nbsp;</td>
		<td align=left valign=top><input size=50 name="NAME" style="HEIGHT: 24px"></td>
	</tr>

<%
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The following script builds dynaimc form containing prompts 
' and fields as specified in the template file whose name is 
' passed as URL parameter.
'
' On submit this dynamic ASP page calls create.asp intermidiate
' ASP script which replaces macro parameters in the template with 
' data entered by the user. The resulting job definition file is 
' finaly gets submited to the 24x7 Scheduler CreateJob method.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim TemplateFile
Dim MacroVarList, JobDefinition, JobScript

' Get URL parameters
TemplateFile = Request("TEMPLATE")
MacroVarList = "NAME,"

' load specified template file into buffer variable
Dim Buffer, FileSystemObj, TextStreamObj
Const ForReading = 1
TemplateFile = Server.MapPath("templates/" & TemplateFile)
Set FileSystemObj = CreateObject("Scripting.FileSystemObject")
Set TextStreamObj = FileSystemObj.OpenTextFile(TemplateFile, ForReading)
Buffer = TextStreamObj.ReadAll
TextStreamObj.Close
Set TextStreamObj=Nothing
Set FileSystemObj=Nothing
	
' not file contents is loaded into a buffer variable
' let's parse it and build dynamic form that will have fields
' required by the selected template
	
Dim StartPos, EndPos, TempPos, BufferLength 'As Long
Dim TextLine, VarName, EditStyle  'As String
Dim VarSection ' As Boolean
	
StartPos = 1
BufferLength = Len(Buffer)
VarSection = False
JobScript = ""
	
Do While StartPos < BufferLength
	' go line by line
	' find CR/LF
	EndPos = InStr(StartPos, Buffer, vbCrLf)
	If EndPos <= 0 Then EndPos = BufferLength
	TextLine = Trim(Mid(Buffer, StartPos, EndPos - StartPos))
		
	If 	TextLine <> "" Then ' not an empty line
		' check if the line starts with a semicolon which indicates comments
		If 	Left(TextLine, 1) <> ";" Then ' this line is not a comment line

			' check if we hit the [Variables] section, if not
			' skip current line 
			If Not VarSection Then
				If TextLine = "[Variables]" Then VarSection = True ' Set flag 
			Else
				' check if we reached post variables section
				If TextLine = "[Body]" Then 
					JobScript = Mid(Buffer, StartPos)
					Exit Do ' break loop
				End If
				
				' check if the line starts with a percent sign 
				' indicating macro-variable		
				If Left(TextLine, 1) = "%" Then
					' get name of the variable and edit style
					TempPos = InStr(3, TextLine, "%")
					If TempPos <= 2 Then ' error
						Response.Write "<h2>Template Error: Invalid template file format in line: " & _
									  Server.HTMLEncode(TextLine) & "</h2>"
						Exit Do
					End If
						
					VarName = Mid(TextLine, 2, TempPos - 2)
					' add variable to the list
					MacroVarList = MacroVarList & VarName & ","
						
					TempPos = InStr(TempPos + 1, TextLine, "=")
					If TempPos <= 0 Then ' error
					   Response.Write "<h2>Template Error: Invalid template file format in line: " & _
									  Server.HTMLEncode(TextLine) & "</h2>"
						Exit Do
					End If
						
					' get edit style for the current variable
					' and add new field to the form
					TextLine = Trim(Mid(TextLine, TempPos + 1))
					TempPos = InStr(1, TextLine, ",")
					If TempPos <= 0 Then ' error
						Response.Write "<h2>Template Error: Invalid template file format in line: " & _
									  Server.HTMLEncode(TextLine) & "</h2>"
						Exit Do
					End If
						
					EditStyle = Trim(Left(TextLine, TempPos - 1))
					' add prompt and form field, whose type depends on the edit style
					If EditStyle = "YES/NO" Then ' add check box
						Response.Write vbTab & "<tr>" & vbCrLf & _
							vbTab & vbTab & "<td align=left valign=top>" & _
								Server.HTMLEncode(Mid(TextLine, TempPos + 1)) & _
							vbTab & vbTab & "<br>&nbsp;</td>" & vbCrLf & _
							vbTab & vbTab & "<td align=left valign=top>" & _
								"<input size=1 name=""" & VarName & """ style=""HEIGHT: 24px""></td>" & vbCrLf & _
							vbTab & "</tr>"
					Else ' all other styles
						Response.Write vbTab & "<tr>" & vbCrLf & _
							vbTab & vbTab & "<td align=left valign=top>" & _
								Server.HTMLEncode(Mid(TextLine, TempPos + 1)) & _
							vbTab & vbTab & "<br>&nbsp;</td>" & vbCrLf & _
							vbTab & vbTab & "<td align=left valign=top>" & _
								"<input size=255 name=""" & VarName & """ style=""HEIGHT: 24px; WIDTH: 333px""></td>" & vbCrLf & _
							vbTab & "</tr>"
					End IF
				Else
					' current line contains regular job property
					JobDefinition = JobDefinition & TextLine & vbCrLf
				End If
			End IF
		End IF
	End If
		
	' process next line
	StartPos = EndPos + 2
Loop

' add hidden field containing main job definiton section
Response.Write		vbTab & "<tr>" & vbCrLf & _
					vbTab & vbTab & "<td></td>" & vbCrLf & _
					vbTab & vbTab & "<td><input type=""hidden"" name=""JOB_DEFINITION"" value=""" & Server.HTMLEncode(JobDefinition & vbCrLf & JobScript) & """></td>" & vbCrLf & _
					vbTab & "</tr>" & vbCrLf 



' add hidden field to store list of macro-variable names
Response.Write		vbTab & "<tr>" & vbCrLf & _
					vbTab & vbTab & "<td></td>" & vbCrLf & _
					vbTab & vbTab & "<td><input type=""hidden"" name=""MACRO_VAR_LIST"" value=""" & Server.HTMLEncode(MacroVarList) & """></td>" & vbCrLf & _
					vbTab & "</tr>" & vbCrLf 
%>
					
	<tr>
		<td></td>
		<td align=right>
			<input type="submit" value="Submit">&nbsp;
			<input type="reset" value="Reset">
		</td>
	</tr>
</table>
</form>

</body>
</html>


